/************************ DATAREC.H ***********************/
/* Record structures for files written and read from disk
		for DAN
		last mod: 10/5/88
*/

/* HEADER RECORD */
/* NOTE: A HEADER RECORD IS NOT NECESSARY FOR PROPER DAN OPERATION */
struct	header_record {
	int		hr_type,			/* record type (= 1) */
			hr_attrib,			/* file attribute codes (TBD) */
			hr_num_recs,		/* number of data records */
			hr_smooth;			/* smoothing factor used */
	char	hr_date[10],		/* date file created */
			hr_label[80],		/* label information */
			hr_xunits[80],		/* X axis units name for data in this file */
			hr_yunits[80];
	double	hr_start,			/* start time for data */
			hr_bias,			/* bias time */
			hr_dur,				/* processing time duration (seconds) */
			hr_step;			/* time incr between successive data pts (seconds) */
	char	hr_version[4];		/* DAN version number */
};
typedef struct header_record HR;



struct datapt {
		double	x,				/* time tag or x coord assoc with data point */
				fx;				/* f(x),data point value or y coord */
};



/* DATA_RECORD - defines DAN Data File format.
				Files written with records in this format can be used
				directly in DAN expressions.
*/
struct data_record {
	int		dr_type,			/* record type (=7) */
			dr_pts,				/* num data pts in record (0-63)*/
			dr_rec_num,			/* current record number (these values are not) */
			dr_nxt_rec;			/* next record number    ( used by DAN      ) */
			/* up to 63 data points per rec */
	struct	datapt dp[63];
	int		dr_slop[4];			/* fill out record to 1024 bytes */
};
typedef struct data_record DR;



/* OUTPUT_FILE  - structure used by 'store_data' routine */
struct output_file {
	int	open;					/* file status flg:     */
								/*    0 = not opened    */
								/*    1 = open          */
								/*    2 = unable to open */
								/*    3 = unrecoverable write error */
	FILE *fid;					/* file stream ptr */
	char name[40];				/* file name */
	DR	*bfr;					/* ptr to output buffer */
};
typedef struct output_file OF;
